type 'a t = 'a list

let empty = []

let length = List.length

let is_empty = function
  [] -> true
| _ -> false

let enqueue v q = q @ [v]
let dequeue (v::q) = v, q

let rec common_prefix q1 q2 =
match q1, q2 with
  d1::ds1, d2::ds2 when d1 = d2 -> d1::common_prefix ds1 ds2
| _ -> []

let rec ndequeue n q =
if n <= 0 then
  q
else
  match q with
    [] -> []
  | d::ds -> ndequeue (n-1) ds
